--amazon,googleplay,android,samsung,blackberry,apple,windows
vendor = 'googleplay'
--set to true to unlock all teams
debugTeams = false
--click on locked team unlocks it
debugPurchases = false
--show buttons my/oni/czas on the mid field while in tournament
debugWinConditions = false

kolorWroga1 = '248,229,64,255'
kolorWroga2 = '0,229,64,255'

kolorGracza1 = '255,255,255,255'
kolorGracza2= '200,0,0,255'

selectedTeam = 'Poland'
enemyTeam = 'Germany'

golePolska = 0
goleWrog = 0
czas = 90
training = nil

fakeForce = true 

catchBallSound = nil
whistle = nil
mobile = false
lastPlayedTeam = nil
--var with t. stage
 tournamentStage = nil
 --var with t. outcomes
 tournamentRound1 = nil
 tournamentRound2 = nil
 tournamentRound3 = nil
 quitDuringMatch = nil
 muteMusic = nil
 
local initialized = false
function initPrefabs(_scn)
	if not initialized then
		math.randomseed(sys.getTimeUTC())
		initialized = true
		--load scripts
		resource.createFromString([[
		<Script Name="main" Type="lua" />
			<File Name="main" Location="main.lua" FileType="lua" 
			Preload="true" Script="main" />
		<Script Name="bieg" Type="lua" />
			<File Name="bieg" Location="bieg.lua" FileType="lua" 
			Preload="true" Script="bieg" />
		<Script Name="pole" Type="lua" />
			<File Name="pole" Location="pole.lua" FileType="lua" 
			Preload="true" Script="pole" />
		<Script Name="market" Type="lua" />
			<File Name="market" Location="market.lua" FileType="lua" 
			Preload="true" Script="pole" />
		<Script Name="ladder" Type="lua" />
			<File Name="ladder" Location="ladder.lua" FileType="lua" 
			Preload="true" Script="ladder" />
		<Script Name="team_picker" Type="lua" />
			<File Name="team_picker" Location="team_picker.lua" FileType="lua" 
			Preload="true" Script="team_picker" />
			
		<Variable name="response" type="string" />
		<RemoteReq Name="Request1" URL="http://laggyluk.com/fufa2014scores.php" 
			Data="name=test" > 
			<Header Name="Content-Type" Value="application/x-www-form-urlencoded" /> 
			<Actions name="GotData">
				<Action method="CallGlobalScript" p1="gotData" />
			</Actions>
		</RemoteReq>
		]])
		reorient(_scn)
		resource.createFromString(prefabs)		
		initMarket()
		--get system id
		if variable.get(variable.find('system',scena),4)~=8 then	
			fakeForce=false
			print("running on mobile")
			mobile = true
		end			
		--init sound
		catchBallSound = resource.find('catch_ball','sound')
		whistle = resource.find('whistle', 'sound')
		goalSound = resource.find('goal','sound')
		media.playSound(catchBallSound)
		resource.createFromString([[
			<ActorParticles Name="SnowyParticles" Image="actorsAtlas" Position="0, 0" Scale="1.0"
			Depth="1.0" Layer="1" PosMode="random" AngVelMode="random" VelMode="random"
			AngMode="random" ScaleMode="random" DepthMode="random" DepthVelMode="random"
			PositionRange="800, 480" AngleRange="0, 360" AngVelRange="-25, 25"
			ScaleRange="0.5, 1" DepthRange="0.1, 2.0" VelRange="-20, 20, -60, 0"
			ScaleVelRange="0, -0.1" DepthVelRange="-0.03, 0.01">
			<Particle Count="300" Position="0, 0" VelocityDamping="0.99, 0.99"
			SrcRect="1,41,64,64" ColourVelocity="0, 0, 0, -20" Duration="16" Repeat="-1"
			SpawnDelay="0.666" Gravity="0, 15" />
			</ActorParticles>
		
		]],_scn)
		--create animation for ads moving btn
		resource.createFromString([[
		<animation name="moveBtn" duration="]] ..adDuration ..[[" type="vec2">
			<frame value="]] .. -screenW2 .. ',' .. screenH2-32 .. [[" time="0" />
			<frame value="]] .. screenW2 .. ',' .. screenH2-32 .. [[" time="7" />
		</animation>]])
		--create variables
		resource.createFromString([[
			<Variable name="lastPlayedTeam" type="string" value="Poland" instant="1" persistent="1" />
			<Variable name="Polando" type="int" value="1" instant="1" persistent="1" />
			<Variable name="Germanyo" type="int" value="0" instant="1" persistent="1" />
			<Variable name="Brazilo" type="int" value="0" instant="1" persistent="1" />
			<Variable name="Russiao" type="int" value="0" instant="1" persistent="1" />
			<Variable name="Franceo" type="int" value="0" instant="1" persistent="1" />
			<Variable name="Italyo" type="int" value="0" instant="1" persistent="1" />
			<Variable name="UKo" type="int" value="0" instant="1" persistent="1" />
			<Variable name="USAo" type="int" value="0" instant="1" persistent="1" />
			<Variable name="Saudi Arabiao" type="int" value="0" instant="1" persistent="1" />
			<Variable name="Turkeyo" type="int" value="0" instant="1" persistent="1" />
			<Variable name="Mexicoo" type="int" value="0" instant="1" persistent="1" />
			
			<variable name="wreon" type="int" value="0" instant="1" persistent="1" />
			<variable name="tournamentStage" type="int" value="0" instant="1" persistent="1" />
			<variable name="tournamentRound1" type="arraystring" size="8" value="" instant="1" persistent="1" />
			<variable name="tournamentRound2" type="arraystring" size="4" value="" instant="1" persistent="1" />
			<variable name="tournamentRound3" type="arraystring" size="2" value="" instant="1" persistent="1" />	
			
			<variable name="muteMusic" type="int" value="0" instant="1" persistent="1" />			
			<variable name="uw" type="string" value="]] .. randomString(8) .. [[" instant="1" persistent="1" />			
			
		]])
		tournamentStage = variable.find('tournamentStage')
		tournamentRound1 = variable.find('tournamentRound1')
		tournamentRound2 = variable.find('tournamentRound2')
		tournamentRound3 = variable.find('tournamentRound3')
		quitDuringMatch= variable.find('wreon')		
		if debugTeams then 
			variable.set(variable.find('Germanyo'),1)
			variable.set(variable.find('Brazilo'),1)
			variable.set(variable.find('Russiao'),1)
			variable.set(variable.find('Franceo'),1)
			variable.set(variable.find('Italyo'),1)
			variable.set(variable.find('UKo'),1)
			variable.set(variable.find('USAo'),1)
			variable.set(variable.find('Saudi Arabiao'),1)
			variable.set(variable.find('Turkeyo'),1)
			variable.set(variable.find('Mexicoo'),1)
		end
		lastPlayedTeam = variable.find('lastPlayedTeam')
		selectedTeam = variable.get(lastPlayedTeam)
		--cheat check
		if variable.get(variable.find(selectedTeam ..'o'))==0 then
			selectedTeam='Poland'
		end
		muteMusic = variable.find('muteMusic')
		if variable.get(muteMusic)==0 then
			media.playMusic("szopen.mp3", 0) 
		end			
	end
	--sys.loadXoml('ladder.xml')
	return 1
end

function replayGame(bla,train)
	
	
	local scn = scene.find('gameOver')
	if scn~=nil then scene.destroy(scn) end
	scn = scene.find('bieg')
	if scn~=nil then scene.destroy(scn) end
	scn = scene.find('pole')
	if scn~=nil then scene.destroy(scn) end
	scn = scene.find('bramka')
	if scn~=nil then scene.destroy(scn) end
	scena=nil
	pole=nil
	bramka=nil
	training=train
	if train~=nil then
		
		sys.loadXoml(training)
	else
		--zaczynamy turniej
		--wygeneruj pary do turnieju i scene ladder		
		--sys.loadXoml('bieg.xml')
		sys.loadXoml('teamPicker.xml')
	end
	return 1
end

function playMatchBtn(_btn,trainmap)	
	training = trainmap
	local sc = scene.getCurrent()
	if trainmap == '' or trainmap == nil then
	--start/resume tournament here if tournamentStage==0
	local p = ''
	if variable.get(tournamentStage)==0 then
		--freeMap(nil,'mainMenu','teamPicker')
		p = 'teamPicker'
	else
		--freeMap(nil,'mainMenu','ladder')
		p = 'ladder'
	end
	
	resource.createFromString([[
		<actions name="end" >
			<action method="killscene" />
			<action method="loadXoml" p1="]] .. p .. [[.xml" />
		</actions>]],sc)		
	else
		resource.createFromString([[
		<actions name="end" >
			<action method="killscene" />
			<action method="callglobalscript" p1="replayGame" p3="]] .. trainmap .. [["/>
		</actions>]],sc)
	end
	resource.createFromString([[
		<timeline name="scenebounce" autoplay="1" timescale="0.5" >
			<animation anim="scenebounceout" target="scale" onEnd="end" repeat="1"/>
		</timeline>
		]],sc)
		
	scene.set(sc,'timeline','scenebounce')	
	return 1
end

--when backing from tournament match let know player
--that it terminates tournament
callerScene = ''

function backBtn(_btn)	
	local _scn = scene.getCurrent()
	if training==nil then
		print('backing up from tournament')
		--sys.loadXoml('forfiter.xml')		
		initForfiter('forfiter')
	else
		freeMap('',scene.get(_scn,'name'),'mainMenu')
	end
	return 1
end

function initForfiter(typ)
	callerScene = scene.get(scene.getCurrent(),'name')
	sys.loadXoml('forfiter.xml')
	local _scn = scene.find('forfiter')
	local text = ''
	local buttons = ''
	if typ=='forfiter' then
		text = 'If you quit during the match you will forfeit the tournament!'
		buttons = [[<label style="button" text="Cancel" onTapped="cancel" margin="10,10,10,10"
						backgroundColour="100,200,100,255" size="-40,-80">
						<Actions name="cancel" >
							<Action method="settimeline" p1="bounceout" p2="container"/>
						</Actions>
					</label>					
					<label style="button" text="Quit" onTapped="ok" margin="10,10,10,10" 
						backgroundColour="200,100,100,255" size="-40,-80">
						<Actions name="ok" >
							<Action method="killscene" />
							<Action method="killscene" p1="]] .. callerScene.. [["/>
							<Action method="loadXoml" p1="mainMenu.xml" />
							<Action method="setVar" p1="tournamentStage" p2="0" />
						</Actions>
					</label>]]
	elseif typ=='winner' then
		text = 'You have won the match!'
		buttons = [[
		<label style="button" text="YEAA!" onTapped="cancel" margin="10,10,10,10"
			backgroundColour="100,200,100,255" size="-40,-80">
			<Actions name="cancel" >
				<Action method="KillScene" />
				<Action method="killscene" p1="]] .. callerScene.. [["/>
				<Action method="addVar" p1="tournamentStage" p2="1" />
				<Action method="setVar" p1="wreon" p2="0" />
				<Action method="loadXoml" p1="ladder.xml" />								
			</Actions>			
		</label>]]
		media.playSound(resource.find('goal','sound'))
	elseif typ=='looser' then
		text = 'You have lost!'
		buttons = [[
		<label style="button" text=":(" onTapped="cancel" margin="10,10,10,10"
			backgroundColour="100,200,100,255" size="-40,-80">
			<Actions name="cancel" >
				<Action method="KillScene" />
				<Action method="killscene" p1="]] .. callerScene.. [["/>
				<Action method="setVar" p1="tournamentStage" p2="0" />
				<Action method="loadXoml" p1="mainMenu.xml" />
			</Actions>			
		</label>]]
		media.playSound(resource.find('buu','sound'))
	elseif typ=='drawer' then
		text = "it's a draw. Overtime!"
		buttons = [[
		<label style="button" text="OK!" onTapped="tap" margin="10,10,10,10"
			backgroundColour="100,200,100,255" size="-40,-80">
			<Actions name="tap" >
				<Action method="KillScene" />
				<Action method="killscene" p1="]] .. callerScene.. [["/>				
				<Action method="loadXoml" p1="bieg.xml" />
				<Action method="Inline" p1="czas = 10;" />
			</Actions>			
		</label>]]		
	end
	--create panel with message
	resource.createFromString([[
		<icon name="dialog" size="-100,-100" tappable="0" layer="9">
			<StackPanel name="container" orientation="vertical" size="-70,-60" brush="panel" scale="0.001,0.001"
				backgroundColour="186,85,211,255" layer="9" tappable="0" timeline="bounceIn">
				<timeline name="bounceIn" autoplay="1" >
					<animation anim="bounceIn" repeat="1" target="scale" />
				</timeline>
				<timeline name="bounceOut" autoplay="1" >
					<animation anim="bounceOut" repeat="1" target="scale" onEnd="close"/>
				</timeline>
				<Actions name="close" >
					<Action method="killscene" />
					<Action method="setCurrentScene" p1="]] .. callerScene .. [[" />
				</Actions>
				<label text="]] .. text ..[[" 
					font="serifMed" size="-80,-70" textColour="30,30,100,255" />
				<StackPanel name="buttons" size="-80,-30" >
					]] .. buttons .. [[
				</StackPanel>
			</StackPanel>
		</icon>	]],_scn)
	return 1
end

local lastTime =0
function updateTime(leWtf)	
	--if training~=nil then return 1 end
	if lastTime-sys.getTimeMs()<=0 then
		local intr = 0.06	
		if paused then  intr=0.001 end
		czas=czas- intr
		local txt = czas
		if training==nil then
			if leWtf ==nil then
				actor.set(czasLbl,"text",string.format('%.2f',txt))
			else 
				actor.set(leWtf,"text",string.format('%.2f',txt))
			end
			if czas <=0 then  			
				print('koniec!')
				--scene.set(scene.getCurrent(),'active',0)
				actor.set(czasLbl,"text","0:00")
				media.playSound(whistle)				
				if goleWrog > golePolska then 
					--come='Time over - you lose!'
					initForfiter('looser')
				end
				if goleWrog< golePolska then 
					--come='Time over - you win!' 
					initForfiter('winner')
				end
				if goleWrog == golePolska then 
					--come='Time over - draw!' 
					initForfiter('drawer')
				end				
			end
		end
		lastTime = sys.getTimeMs()+ 100
	end
end


function reklama_tick(lolo)
	--local w =
	--actor.set(w,"text",string.format('%.2f',czas))
	--updateTime( actor.find('someCounter',lolo))
	return 0
end

function kickAdsBall(_scn)
	print('kickAdsBall::')
	if scena~=nil then scene.set(scena,'visible',0) end
	local pila = actor.find('pilka',_scn)
	actor.set(pila,'active',1)
	scene.set(_scn,'physics',1)
	scene.set(_scn,'current',1)
	actor.set(pila,'linearimpulse','200,-200')
	return 1
end

function loadAds(_btn)
	local scn = scene.find('reklama')
		oldPos = scene.get(scn,'position')
		resource.createFromString([[
		<Actions name="end" >
			<Action Method="CallGlobalScript" p1="kickAdsBall" />
		</Actions>
		<Animation name="newmove" type="vec2" duration="1" >					
			<Frame value="]] ..-screenW*1.5  .. ',0' .. [[" time="0" />
			<Frame value="]] .. '0,0' .. [[" time="1" />
		</Animation>
		<Timeline name="newmove" autoplay="1" >
			<animation anim="newmove" target="position" onEnd="end" repeat="1" />				
		</Timeline>
		]],scn)
		scene.set(scn,'timeline','newmove')
		scene.set(scn,'active',1)
	return 1
end

function createAdView()
	local _scn = scene.getCurrent()
	local link = '544831646'
	if getVendor()=='windows' then 
		--print('showing windows ad')
		link = '778775528' 		
	else		
	end
	print('showing mobile ad')
		resource.createFromString([[
		<canvas name="bg" size="-100,-100" brush="whiterect" backgroundcolour="128,128,128,255" />
		<WebView Name="ad_view" Position="0, 0" Size="-100, -80" layer="8" />
		]],_scn)
		actor.set(actor.find('ad_view',_scn),'html',
		[[<html>
			<head>
				<meta name="viewport" content="width=device-width, initial-scale=1.0, initial-scale=1.0, minimum-scale=1.0, maximum-scale=10.0, user-scalable=no" />
			</head>
			<body style="margin:0; padding:0; text-align:center;">
				<script type="text/javascript" src="http://ad.leadboltads.net/show_app_ad.js?section_id=]] .. link .. [["></script>
			</body>
	</html>]])
	return 1
end

function initReklama(_scn)
	print('reklama init')
	reorient()
	relamaScene = _scn
	paused=false
	local w = screenW*0.65
	local h = screenH *0.50
	
	if  mobile then
		local ballBtn = actor.find('ballBtn',_scn)
		local range = screenW2*0.8
		
		createAdView()
		resource.createFromString([[
		<Actions name="showCloseBtn" >
			<Action Method="setProperty" p1="visible" p2="true" p3="closeAdsBtn" />
			<Action Method="setProperty" p1="positionx" p2="]] .. math.random(-range,range) .. [["  p3="closeAdsBtn" />
		</Actions>
		<Timeline name="moveBtn" autoplay="1" >
			<animation anim="moveBtn" target="position" onEnd="showCloseBtn" repeat="1"/>
			<animation anim="spin" target="angle" />
		</Timeline>
		]],ballBtn)
		actor.set(ballBtn,'timeline','moveBtn')
	else
		resource.createFromString([[
		<canvas name="bg" size="-100,-100" brush="whiterect" />
		<Label Name="Ads" text="your ad here" docking="top" layer="2" Size="-100, -15" font="serif" textColour="0,0,0,255" />
		]],_scn)
		scene.set(_scn,'position', -screenW*1.5 .. ',0')	
		resource.createFromString([[
		<Actions name="loaded">
			<Action method="setProperty" p1="active" p2="false" />
		</Actions>
		<Timeline name="wait" autoplay="1" >
			<animation anim="dummyfade" target="opacity" onEnd="loaded" />
		</Timeline>
		]],_scn)
		scene.set(_scn,'timeline','wait')
	end
	
	
	return 1
end


function hideAds()
	print('hide ads')
	local _scn = scene.find('reklama')
	scene.set(_scn,'physics',0)
	local pila = actor.find('pilka',_scn)
	actor.set(pila,'visible',0)
	resource.createFromString([[
		<Actions name="die" >
			<Action Method="CallGlobalScript" p1="freeMap" p3="reklama" p4="bieg"/>
		</Actions>
		<Animation name="oldmove" type="vec2" duration="1" >					
			<Frame value="0,0" time="0" />
			<Frame value="]] ..screenW .. ',0' .. [[" time="1" />
		</Animation>
		<Timeline name="oldmove" autoplay="1" >
			<animation anim="oldmove" target="position" onEnd="die" repeat="1" />
		</Timeline>
		]],_scn)
	scene.set(_scn,'timeline','oldMove')
	--create new scene
	return 1
end


function rateMe()
	if vendor== 'googleplay' then		
		sys.launchURL("https://play.google.com/store/apps/details?id=com.laggyluk.fufa2014")
	elseif vendor=='blackberry'  then
		
	elseif vendor=='amazon'then
		sys.launchURL('http://www.amazon.com/gp/mas/dl/android?asin=B00LFQDMM6')
	elseif vendor=='apple' then
		sys.launchURL('http://itunes.apple.com/WebObjects/MZStore.woa/wa/viewContentsUserReviews?id=879794953&pageNumber=0&sortOrdering=2&type=Lukasz+Karasowski&mt=8')
	elseif vendor=='samsung' then
		sys.launchURL('samsungapps://ProductDetail/com.bryancolin.turkeybounce')
	elseif vendor=='android' then --pre-play
	
	elseif vendor=='windows' or vendor=='wp8' then --win phone 8
		sys.launchURL('zune:reviewapp?appid=64031laggyluk.623144694D542')
	end	
	return 1
end

function muteToggle(_btn)
		if variable.get(muteMusic)==1 then 
			variable.set(muteMusic,0)
			media.playMusic("szopen.mp3", 0) 
		else 
			variable.set(muteMusic,1) 
			media.stopMusic()
		end		
	return 1
end

prefabs = [[

<Style name="button" >
	<Set Property="brush" Value="guzik" />
	<Set Property="font" Value="serifMed" />
	<Set Property="tappable" Value="1" />
	<Set Property="TextColour" Value="40,40,40,255" />	
</Style>

<animation name="scenebounceout" duration="0.3" type="float">
	<frame value="1" time="0" />
	<frame value="1.1" time="0.1" />
	<frame value="0" time="0.3" />
</animation>

<animation name="spin" duration="1" type="float">
	<frame value="0" time="0" />
	<frame value="-360" time="1" />
</animation>
<animation name="dummyfade" duration="1" type="float">
	<frame value="255" time="0" />
	<frame value="255" time="1" />
</animation>
<animation name="fadein" duration="1" type="float">
	<frame value="0" time="0" />
	<frame value="255" time="1" />
</animation>
<animation name="fadeout" duration="1" type="float">
	<frame value="255" time="0" />
	<frame value="0" time="1" />
</animation>

<animation name="bounceIn" duration="0.5" type="vec2">
	<frame value="0,0" time="0" />
	<frame value="1.1,1.1" time="0.4" />
	<frame value="1,1" time="0.5" />
</animation>

<animation name="bounceOut" duration="0.5" type="vec2">
	<frame value="1,1" time="0" />
	<frame value="1.1,1.1" time="0.1" />
	<frame value="0,0" time="0.5" />
</animation>

<animation name="selected" duration="1.4" type="vec2">
	<frame value="1,1" time="0" />
	<frame value="1.1,1.1" time="0.7" />
	<frame value="1,1" time="1.4" />
</animation>

<template name="bramkarzT" >
	<Icon name="$name$" size="$size$" brush="$brush$" position="$pos$" 
		layer="2" depth="1.2" box2dmaterial="kinematic" collisionflags="1,1,1">
	</Icon>
</template>

]]
