--max kick str
kickStrength = 1000
--how long round lastas after btn press
roundTime  =2000

catchBallSound = nil
pole = nil
local playTime = 0
local players = nil
local niemcy = nil
local pilka = nil

local pilkaPos = nil
local deltaT = 0
local slupekL, slupekR = nil,nil
local pilaZlapana = false
local wynikLbl = nil
timeStep = 0.001
local goLbl =  nil

function initPole(_scn)
	paused = true
	pilaZlapana = true
	pole = _scn
	--some chance to get rid of second player pion
	for i=1, math.random(1)do
	resource.createFromString([[		
		<Icon Name="pilkarz]] .. i .. [[" Position="-336.64,136.96" Layer="2" Background="wlosy" Size="32,32" OnCollisionEnd="col" Type="1" VelocityDamping="0.9,0.9" AngularVelocityDamping="0.9999999" 
		  Box2dMaterial="gracznapolu" Shape="pilkarz"  collisionflags="1,1,1">
			 <Modifiers>
				<Modifier Name="iw_notifycollision" Active="1" />
			</Modifiers>
			<Actions Name="col" >
				<Action Method="CallGlobalScript" P1="pilkarzPilkaHitEnd" />
			</Actions>
		  <Icon Name="vector" Position="0,0" Layer="3" backgroundColour="0,255,255,150" Background="circle" Size="50,50"  Draggable="1" HoldFocus="1" Type="0" />
		</Icon>]],_scn)
	end
	players = actor.findOfType(1,_scn)
	local range = screenW2*0.8
	if players~=nil then
		for k,v in pairs(players) do
			actor.set(v,'backgroundColour',kolorGracza2)
			actor.set(v,'positionx',math.random(-range,range))
		end
	end	
	niemcy =  actor.findOfType(3,_scn)
	if niemcy~=nil then
		for k,v in pairs(niemcy) do
			actor.set(v,'backgroundColour','0,0,0,255')
		end
	end
	wynikLbl = actor.find('wynikLbl',pole)
	actor.set(wynikLbl,"Text",golePolska .. ':' .. goleWrog)
	pilka = actor.find('pilka1',_scn)
	--pilka do nogi gracza
	actor.set(pilka,'positionx',actor.get(players[1],'positionx')*0.8)
	actor.set(pilka,'positiony',actor.get(players[1],'positiony')*0.8)
	slupekL = actor.find('lslup',pole)
	slupekR = actor.find('rslup',pole)
	czasLbl = actor.find("counter",pole)
	
	--resize some ui elements to rozsadne rozmiary
	goLbl = actor.find('goLbl1',pole)	
	local ssize = aspectSize('xy',10)
	actor.set(goLbl,'size',ssize .. ',' .. ssize)
	return 1
end

local lastFrameT = 0
function pole_tick(_scn)
	deltaT = math.max(( sys.getTimeMs()- lastFrameT ) / 1000,0.001)
	if paused==false and playTime-sys.getTimeMs()<=0  and pilaZlapana==false then
		paused = true
		timeStep = 0.001
		scene.set(_scn, 'PhysicsTimestep',timeStep)
		print('turn end')
	end
	pilkaPos = actor.get(pilka,'position')
	--check if pilka is not outside of screen
	if pilkaPos.x>screenW2 or pilkaPos.x<-screenW2 or pilkaPos.y>screenH2 or pilkaPos.y<-screenH2 then
		changeToBieg()
		return 1
	end
	--now check if players are not outside of field
	if players~=nil then
		for k,v in pairs(players) do
			local pos = actor.get(v,'position')
			if pos.x>screenW2 or pos.x<-screenW2 or pos.y>screenH2 or pos.y<-screenH2 then
				changeToBieg()
				return 1
			end
		end
	end	
	updateTime()
	lastFrameT = sys.getTimeMs()
	return 1
end

function poleGo(_btn)
	pilaZlapana = false
	if paused==false then return 1 end
	for k,v in pairs(players) do 
		local p = actor.children(v)
		p  =  p[1]
		local dir = actor.get(p,'position')		
		dir = vec.new(dir.x,dir.y)--zero the u,v vec components for normalize
		--print('impuls ' ..dir.x ..'  ' .. dir.y)
		local d = distance(dir.x,dir.y,0,0)
		if dir.x~=0 or dir.y~=0 then			
			dir = vec.normalize(dir)
			print(dir)
			actor.set(v,'linearimpulse',dir*math.min(d,kickStrength))
		end
		actor.set(p,'position','0,0')
	end
	playTime = sys.getTimeMs()+ roundTime
	paused = false
	timeStep=0.0333333
	scene.set(pole, 'PhysicsTimestep',timeStep)
	return 1
end

function pilkarzPilkaHitEnd(_pilkarz)
	--when bumping on a ball set angle to 0
	actor.set(_pilkarz,'angularvelocity',0)
	actor.set(_pilkarz,'angle',0)
	local collisions_started = actor.getEndContacts(_pilkarz)
	if (collisions_started == nil) then return 0 end
	for k,v in pairs(collisions_started) do
		--actor.set(v,'torque',300)
		--print('aaa')

	end
	return 1
end

function printPos(_obj)
	print(actor.get(_obj,'position'))
	return 1
end

local maxMove = 30
function bramkarzTick(_obj)
	 if pilaZlapana then return 2 end
	 local lePos = actor.get(_obj,'position')
	 --catch ball?
	local collisions_started = actor.getStartContacts(_obj)
	if (collisions_started ~= nil) then 
		for k,v in pairs(collisions_started) do
			--actor.set(v,'torque',300)
			--print('aaa')
			local typ = actor.get(v,'type')
			if typ==2 then
				pilaZlapana = true
				local lePosB = actor.get(v,'position')
				print('pila zlapana!')
				actor.set(v,'velocity','0,0')
				actor.set(_obj,'collidable',0)
				actor.set(_obj,'velocity','0,0')
				scene.set(pole,'physics',0)
				media.playSound(catchBallSound)
				actor.set(_obj,'position',lePos)
				actor.set(v,'position',lePosB)				
				actor.set(goLbl1,'visible',0)
				changeToBieg()
				return 1
			elseif typ==1 then--kolizja bramkarza z playerem
				pilaZlapana = true
				media.playSound(whistle)
				changeToBieg()
			end			
		end
	end
	local pos = actor.get(_obj,'position')
	--jezeli bramkarz jest blizej niz jakikolwiek 
	--przeciwnik to niech biegnie do pily
	local distToBall = actor.distance(_obj,pilka)
	local flag=false
	for k,v in pairs(players) do
		if actor.distance(v,pilka)<distToBall then 
			flag = true
			break
		end
	end
	if flag==false then
		local dif = vec.normalize(pilkaPos - pos)
		actor.set(_obj,'linearimpulse',dif*timeStep*20)
		return 1
	end
	--if not then just move in x axis
	local dif = pilkaPos.x-pos.x
	if dif>0 then 
		dif = math.min(dif,maxMove)* timeStep
	elseif dif<0 then 
		dif = math.max(dif,-maxMove)* timeStep
	end
	dif = round(dif,4)
	--print(dif)
	--dif=0.001
	local slL = actor.get(slupekL,'positionx')
	local slR = actor.get(slupekR,'positionx')
	if pos.x>slL and pos.x<slR then
		actor.set(_obj,'linearimpulse',dif .. ',0.0')
	elseif pos.x<slL  and pos.x<pilkaPos.x then 
		actor.set(_obj,'linearimpulse',dif .. ',0.0')
	elseif pos.x>slR  and pos.x>pilkaPos.x then 
		actor.set(_obj,'linearimpulse',dif .. ',0.0')
	end
	actor.set(_obj,'angle',0)
	return 1
end

function golGol(_det)
	local collisions_started = actor.getStartContacts(_det)
	if (collisions_started == nil) then return 0 end
	for k,v in pairs(collisions_started) do
		--actor.set(v,'torque',300)
		--print('aaa')
		if actor.get(v,'type')==2 then
			golePolska = golePolska+ 1
			
			actor.set(wynikLbl,"Text",golePolska .. ':' .. goleWrog)
			--hide go btn
			actor.set(actor.find('goLbl1',pole),'visible',0)
			media.playSound(goalSound)
			changeToBieg()
		end
	end
	
	return 1
end

function changeToBieg()
	if training~=nil then
		scene.destroy(pole)
		pole = nil
		sys.loadXoml('pole.xml')
		return 1
	end
	---------- fade out scene
	resource.createFromString([[
		<Actions name="die" >
			<Action Method="CallGlobalScript" p1="freeMap" p3="pole" p4="bieg"/>
		</Actions>
		<Timeline name="fadeout" autoplay="1" timescale="0.4">
			<animation anim="fadeout" target="opacity" onEnd="die" repeat="1" />					
		</Timeline>
		]],pole)
	scene.set(pole,'timeline','fadeout')
	return 1
end