--predkosc przesowania sie stuffu
trawaSpeed = 30 
lastObjId = 0
local players = nil
local niemcy = nil
local deltaT = 0
local lastFrameT = 0
local trawaTop = 0
bieg = nil
local nogaL = nil
local nogaR = nil
local bg = nil
local pila = nil
local movables = {}
local bgHeight = 0
local trybuny = nil
local moveLeft,moveRight = false,false
--start button flips it and starts the game
playerReady = false
local trawa = nil
local params = {}
local detektor = nil
local knob = nil

function initBieg(_scn)
	paused = true
	moveLeft,moveRight = false,false
	playerReady = false
	local wtf = scene.find('bramka')
	if wtf~=nil then 
		scene.destroy(wtf) 
		scena=nil
	end
	bieg = _scn
	reorient()
	trawa = {}
	movables = {}
	lastFrameT = sys.getTimeMs()
	trawaTop = -screenH2*0.05
	scene.set(_scn,'size','-100,-100')
	scene.set(_scn,'physics',0)	
	--create background
	bg = resource.create('icon',{
			name="trawa",
			Position="0,"..trawaTop,
			Layer="1",
			Background="trawkaPole",
			Size="-100,-60",
			Tiling="20,10",
			Type="1"
			--angle="-1.3",
			
		},_scn)
	bgHeight = actor.get(bg,"size").y/2
	actor.set(bg,'positiony',trawaTop+bgHeight)
	pila = actor.find('pila',_scn)
	actor.set(pila,'positiony',screenH2*0.3)
	trybuny = actor.find('trybuny',bieg)
	detektor = actor.find('detektor',bieg)
	actor.set(detektor,'positiony',screenH2)
	--set legs position
	nogaL = actor.find('nogaL',bieg)
	nogaR = actor.find('nogaR',bieg)
	local startPos = screenH2*0.95 + 40
	actor.set(nogaL,'positiony',startPos)
	actor.set(nogaR,'positiony',startPos)
	wynikLbl = actor.find('wynikLbl',bieg)
	actor.set(wynikLbl,"Text",golePolska .. ':' .. goleWrog)
	czasLbl = actor.find("counter",_scn)
	--set color
	local players = actor.findOfType(5,_scn)
	if players~=nil then
		for k,v in pairs(players) do
			actor.set(v,'backgroundColour',kolorGracza2)
		end
	end	
	local players = actor.findOfType(6,_scn)
	if players~=nil then
		for k,v in pairs(players) do
			actor.set(v,'backgroundColour',kolorGracza1)
		end
	end	
	if not debugWinConditions then
		actor.set(actor.find('debugGolMy',_scn),'visible',0)
		actor.set(actor.find('debugCzas',_scn),'visible',0)
		actor.set(actor.find('debugGolWrog',_scn),'visible',0)
	end
	
	return 1
end

local randTime = 1000

function bieg_tick(_scn)
	local t = sys.getTimeMs()
	deltaT = math.max(( t - lastFrameT ) / 1000,0.001)
	local pos 
	for k,v in pairs(trawa) do
		pos = actor.get(v,'positiony')
		if pos>screenH2 then 
			actor.destroy(v)
			trawa[k] = nil
		else
			actor.set(v,'positiony',pos+(trawaSpeed*2*deltaT))
		end
		actor.add(v,'depth',-0.2*deltaT)
	end
	force = 0
	--if (fakeForce) then
	--accelerometer simulation using keyboard	
		if input.isKeyDown(23) or moveLeft then
			force =   -200*deltaT
		end
		if input.isKeyDown(26) or moveRight then
			force = 200*deltaT
		end	
	--else
		--[[local accel = input.getAccelerometer()	
		if speedBonus then
			force = string.format("%4.3f",tostring(math.min(accel.x*speedBonusFactor,bonusSpeedLimit)))
		else
			force = string.format("%4.3f",tostring(math.min(accel.x*accelScale,maxXAccel)))
		end]]--
	--end
	if playerReady then 
		--move legs left and right
		--if actor.get(nogaL,'positionx')>screenW2
		actor.add(nogaL,'positionx',force)
		actor.add(nogaR,'positionx',force)
		--move bg
		trawaTop = trawaTop + deltaT*5
		actor.set(bg,'positiony',trawaTop+bgHeight)
		actor.add(trybuny,'positiony',-1*deltaT)
		--generate some moving stuff
		if randTime-t<=0 then
			randTime = math.random(1000,3000)+t
			local obj
			if math.random(0,1)== 1 then
				obj = resource.create('icon',{
					name="grass" ,
					size="40,25",
					brush="grass1",
					layer="2",
					depth="1.2",
					position=math.random(-screenW2,screenW2) .. ',' .. trawaTop
				},bieg)
			else
			local base = resource.create('icon',{
				name='pilarz' .. lastObjId,
				size='-7,-10',
				brush='pilkarz',
				position=math.random(-screenW2,screenW2) .. ',' .. trawaTop -(screenH2*0.2),
				backgroundColour=kolorWroga2,
				aspectlock="x",
				layer="2",
				depth="1.2",
				box2dmaterial="kinematic", collisionflags="1,1,1" 
			},bieg)
			local kolor = resource.create('icon',{
				name='pilarz' .. lastObjId .. 'kolor',
				size="-100,-100",
				brush="pilkarzKolor",
				position="3,-1",
				aspectlock="x"
			},base)
			local kolor2 = resource.create('icon',{
				name='pilarz' .. lastObjId .. 'kolor',
				size="-100,-100",
				brush="pilkarzKolor2",
				backgroundColour=kolorWroga1,
				position="0,-1",
				aspectlock="x"
			},base)
			local godlo = resource.create('icon',{
				size="-20,-10",
				brush="godlo"..enemyTeam,
				position="0," .. actor.get(kolor,'size').y*-0.55,
				aspectlock="x"
			},kolor2)
				
				--obj = actor.find('pilarz' .. lastObjId,bieg)
				obj = base
				lastObjId = lastObjId + 1
			end
			table.insert(trawa,obj)
		end
		--print(trawaTop)
		--dobieglismy do konca, zmien scene
		if trawaTop>125 then
			if training~=nil then
				scene.destroy(bieg)
				bieg = nil
				sys.loadXoml('bieg.xml')
				return 1
			end
			playerReady = false
			scene.set(bieg,'physics',0)
			resource.createFromString([[
				<Actions name="die" >
					<Action Method="CallGlobalScript" p1="freeMap" p3="bieg" p4="pole"/>
				</Actions>
				<Timeline name="fadeout" autoplay="1" timescale="0.4">
					<animation anim="fadeout" target="opacity" onEnd="die" repeat="1" />					
				</Timeline>
				]],bieg)
			scene.set(bieg,'timeline','fadeout')
		end
	end
	updateTime()
	lastFrameT = sys.getTimeMs()
	return 1
end

function sliderDown(_knob)
	print('slider down')
	--local midPos = actor.get(nogaR,'position').x - actor.get(nogaL,'position').x 
	--local knobPos = actor.get(_knob,'position').x
	--midPos = midPos - knobPos	
	return 1
end

function sliderUp(_knob)
	print('slider up')
	return 1
end

function moveLegsBtnDown(_btn,left)
	if left=='true' then moveLeft = true
	else moveRight=true
	end
	return 1
end

function moveLegsBtnUp(_btn,left)
	if left=='true' then moveLeft = false
	else moveRight=false
	end
	return 1
end

function startBieg(_btn)
	paused = false
	--fid which screen dimension is bigger
	if screenH2>screenW2 then
		h = screenW2
	else
		h = screenH2
	end
	--create animations for legs
	local startPos = h*0.95
	local endPos = h*0.8
	resource.createFromString([[
	<Animation name="moveLegL" duration="2" type="float">
		<Frame value="]] .. startPos .. [[" time="0" />
		<Frame value="]] .. endPos .. [[" time="1" />
		<Frame value="]] .. startPos .. [[" time="2" />
	</Animation>
	<Timeline name="moveLegL" autoplay="1" timescale="2">
		<Animation anim="moveLegL" target="positiony" />
	</Timeline>
	]],nogaL)
	actor.set(nogaL,'timeline','moveLegL')
	--second leg
	
	resource.createFromString([[
	<Animation name="moveLegR" duration="2" type="float">
		<Frame value="]] .. endPos .. [[" time="0" />
		<Frame value="]] .. startPos .. [[" time="1" />
		<Frame value="]] .. endPos .. [[" time="2" />
	</Animation>
	<Timeline name="moveLegR" autoplay="1" timescale="2">
		<Animation anim="moveLegR" target="positiony" />
	</Timeline>
	]],nogaR)
	actor.set(nogaR,'timeline','moveLegR')
	playerReady=true
	scene.set(bieg,'physics',1)
	actor.set(_btn,'visible',0)
	--print('screen pos : '   .. startPos)
	--print('screen h : '   .. screenH)
	return 1
end

function detectorBieguHit(_obj)
	local collisions_started = actor.getStartContacts(_obj)
	if (collisions_started == nil) then return 0 end
	for k,v in pairs(collisions_started) do 
		if actor.get(v,'type')==2 then
			--bieg over
			print('bieg over')
			--fade out scene and load bramka
			resource.createFromString([[
				<Actions name="die" >
					<Action Method="CallGlobalScript" p1="loadBramka" />
				</Actions>
				<Timeline name="fadeout" autoplay="1" timescale="0.4">
					<animation anim="fadeout" target="opacity" onEnd="die" repeat="1" />					
				</Timeline>
				]],bieg)
			scene.set(bieg,'timeline','fadeout')
		end
	end
	return 1
end

function loadBramka(_scn)
	if training~=nil then
		scene.destroy(bieg)
		bieg = nil
		sys.loadXoml('bieg.xml')
		--camera.set(cam,'targetx',head)
		return 1
	end
	playerReady = false
	scene.destroy(scene.find('bieg'))
	bieg=nil
	sys.loadXoml('bramka.xml')
	return 1
end