function initHiScores(_scn)
	print('initHighScores')
	local ssize = aspectSize('xy',60)
	resource.create('Webview',{
		size=ssize .. ',' .. ssize,
		--position=-screenW2*0.4 .. ',' .. -screenH2*0.2,
		uri="http://laggyluk.com/fufa2014scores.php" 
	},_scn)
	makeSquare(actor.find('okBtn',_scn),23)	
	return 1
end

function submitScore()
	print('submitting score')
	local req = http.find('Request1')
	local playerId = variable.get(variable.find('uw'))
	local teamId = findKey(teamNames,selectedTeam)
	local payload = 'p=' .. playerId .. '&t=' .. teamId
	--payload=convert(payload,'very6interesting')
	--print(payload)
	http.set(req,'data', payload)
	http.set(req,'post',1)
	http.send(req)
	return 1
end

function gotData(_req)
	print('got data!')
	print(http.responseCode() )
	print(variable.get(variable.find('response')))
	return 1
end

function makeSquare(_a,size)	
	size = aspectSize('xy',size)
	actor.set(_a,'size',size .. ',' .. size)
	return size
end

local function BitXOR(a,b)--Bitwise xor
    local p,c=1,0
    while a>0 and b>0 do
        local ra,rb=a%2,b%2
        if ra~=rb then c=c+p end
        a,b,p=(a-ra)/2,(b-rb)/2,p*2
    end
    if a<b then a=b end
    while a>0 do
        local ra=a%2
        if ra>0 then c=c+p end
        a,p=(a-ra)/2,p*2
    end
    return c
end

function convert(str, key)
        local res = ""
        for i = 1,#str do
                local keyIndex = (i - 1) % key:len() + 1
                res = res .. string.char( BitXOR( str:sub(i,i):byte(), key:sub(keyIndex,keyIndex):byte() ) )
        end
        return res
end
