--amazon,googleplay,android,samsung,blackberry,apple,windows
vendor = 'googleplay'
kolorWroga = '248,229,64,255'
kolorGracza = '200,0,0,255'

golePolska = 0
goleWrog = 0
czas = 90
training = nil

fakeForce = true 
pilkarzT = nil
catchBallSound = nil
whistle = nil
mobile = false

local initialized = false
function initPrefabs(_scn)
	if not initialized then
		initialized = true
		--load scripts
		resource.createFromString([[
		<Script Name="main" Type="lua" />
			<File Name="main" Location="main.lua" FileType="lua" 
			Preload="true" Script="main" />
		<Script Name="bieg" Type="lua" />
			<File Name="bieg" Location="bieg.lua" FileType="lua" 
			Preload="true" Script="bieg" />
		<Script Name="pole" Type="lua" />
			<File Name="pole" Location="pole.lua" FileType="lua" 
			Preload="true" Script="pole" />
		]],_scn)
		reorient()
		resource.createFromString(prefabs)
		--get system id
		if variable.get(variable.find('system',scena),4)~=8 then	
			fakeForce=false
			print("running on mobile")
			mobile = true
		end	
		pilkarzT = template.find('pilkarzT')
		--init sound
		catchBallSound = resource.find('catch_ball','sound')
		whistle = resource.find('whistle', 'sound')
		goalSound = resource.find('goal','sound')
		media.playSound(catchBallSound)
		resource.createFromString([[
			<ActorParticles Name="SnowyParticles" Image="actorsAtlas" Position="0, 0" Scale="1.0"
			Depth="1.0" Layer="1" PosMode="random" AngVelMode="random" VelMode="random"
			AngMode="random" ScaleMode="random" DepthMode="random" DepthVelMode="random"
			PositionRange="800, 480" AngleRange="0, 360" AngVelRange="-25, 25"
			ScaleRange="0.5, 1" DepthRange="0.1, 2.0" VelRange="-20, 20, -60, 0"
			ScaleVelRange="0, -0.1" DepthVelRange="-0.03, 0.01">
			<Particle Count="300" Position="0, 0" VelocityDamping="0.99, 0.99"
			SrcRect="1,41,64,64" ColourVelocity="0, 0, 0, -20" Duration="16" Repeat="-1"
			SpawnDelay="0.666" Gravity="0, 15" />
			</ActorParticles>
		
		]],_scn)
		--create animation for ads moving btn
		resource.createFromString([[
		<animation name="moveBtn" duration="]] ..adDuration ..[[" type="vec2">
			<frame value="]] .. -screenW2 .. ',' .. screenH2-32 .. [[" time="0" />
			<frame value="]] .. screenW2 .. ',' .. screenH2-32 .. [[" time="7" />
		</animation>]])
	end
	return 1
end

function replayGame(bla,train)
	goleWrog = 0
	golePolska = 0
	czas = 90
	
	local scn = scene.find('gameOver')
	if scn~=nil then scene.destroy(scn) end
	scn = scene.find('bieg')
	if scn~=nil then scene.destroy(scn) end
	scn = scene.find('pole')
	if scn~=nil then scene.destroy(scn) end
	scn = scene.find('bramka')
	if scn~=nil then scene.destroy(scn) end
	scena=nil
	pole=nil
	bramka=nil
	training=train
	if train~=nil then
		
		sys.loadXoml(training)
	else
		sys.loadXoml('bieg.xml')	
	end
	return 1
end

function playMatchBtn(_btn,trainmap)
	local sc = scene.getCurrent()
	if trainmap == '' or trainmap == nil then
	resource.createFromString([[
		<actions name="end" >
			<action method="killscene" />
			<action method="callglobalscript" p1="replayGame" />
		</actions>]],sc)
	else
		resource.createFromString([[
		<actions name="end" >
			<action method="killscene" />
			<action method="callglobalscript" p1="replayGame" p3="]] .. trainmap .. [["/>
		</actions>]],sc)
	end
	resource.createFromString([[
		<timeline name="scenebounce" autoplay="1" timescale="0.5" >
			<animation anim="scenebounceout" target="scale" onEnd="end" repeat="1"/>
		</timeline>
		]],sc)
	scene.set(sc,'timeline','scenebounce')
	return 1
end

local lastTime =0
function updateTime(leWtf)	
	--if training~=nil then return 1 end
	if lastTime-sys.getTimeMs()<=0 then
		local intr = 0.04		
		if paused then  intr=0.001 end
		czas=czas- intr
		--local txt = string.gsub(tostring(czas / 1000),"%.",":") .. '0'
		--if string.len(txt)<4 then
		--	txt = string.gsub(tostring(czas / 1000),1,3) .. ':00'
		--end
		--print('tick')
		local txt = czas
		--txt = 'haha'
		if training==nil then
			if leWtf ==nil then
				actor.set(czasLbl,"text",string.format('%.2f',txt))
			else 
				actor.set(leWtf,"text",string.format('%.2f',txt))
			end
		
			--print(czas)
			if czas <=0 then  			
				print('koniec!')
				scene.set(scene.getCurrent(),'active',0)
				actor.set(czasLbl,"text","0:00")
				media.playSound(whistle)
				sys.loadXoml('gameOver.xml')
				local scn = scene.find('gameOver')
				scene.setCurrent(scn)
				scene.set(scn,'Visible',true)
				local a = actor.find('outcome',scn)
				local come = ''
				if goleWrog > golePolska then come='Time over - you lose!' end
				if goleWrog< golePolska then come='Time over - you win!' end
				if goleWrog == golePolska then come='Time over - draw!' end
				actor.set(a,'text',come)			
			end
		end
		lastTime = sys.getTimeMs()+ 100
	end
end


function reklama_tick(lolo)
	--local w =
	--actor.set(w,"text",string.format('%.2f',czas))
	updateTime( actor.find('someCounter',lolo))
	return 0
end

function kickAdsBall(_scn)
	print('kickAdsBall::')
	if scena~=nil then scene.set(scena,'visible',0) end
	local pila = actor.find('pilka',_scn)
	actor.set(pila,'active',1)
	scene.set(_scn,'physics',1)
	scene.set(_scn,'current',1)
	actor.set(pila,'linearimpulse','200,-200')
	return 1
end

function loadAds(_btn)
	local scn = scene.find('reklama')
		oldPos = scene.get(scn,'position')
		resource.createFromString([[
		<Actions name="end" >
			<Action Method="CallGlobalScript" p1="kickAdsBall" />
		</Actions>
		<Animation name="newmove" type="vec2" duration="1" >					
			<Frame value="]] ..-screenW*1.5  .. ',0' .. [[" time="0" />
			<Frame value="]] .. '0,0' .. [[" time="1" />
		</Animation>
		<Timeline name="newmove" autoplay="1" >
			<animation anim="newmove" target="position" onEnd="end" repeat="1" />				
		</Timeline>
		]],scn)
		scene.set(scn,'timeline','newmove')
		scene.set(scn,'active',1)
	return 1
end

function createAdView()
	local _scn = scene.getCurrent()
	local link = '544831646'
	if getVendor()=='windows' then 
		--print('showing windows ad')
		link = '778775528' 		
	else		
	end
	print('showing mobile ad')
		resource.createFromString([[
		<canvas name="bg" size="-100,-100" brush="whiterect" backgroundcolour="128,128,128,255" />
		<WebView Name="ad_view" Position="0, 0" Size="-100, -80" layer="8" />
		]],_scn)
		actor.set(actor.find('ad_view',_scn),'html',
		[[<html>
			<head>
				<meta name="viewport" content="width=device-width, initial-scale=1.0, initial-scale=1.0, minimum-scale=1.0, maximum-scale=10.0, user-scalable=no" />
			</head>
			<body style="margin:0; padding:0; text-align:center;">
				<script type="text/javascript" src="http://ad.leadboltads.net/show_app_ad.js?section_id=]] .. link .. [["></script>
			</body>
	</html>]])
	return 1
end

function initReklama(_scn)
	print('reklama init')
	reorient()
	relamaScene = _scn
	paused=false
	local w = screenW*0.65
	local h = screenH *0.50
	
	if  mobile then
		local ballBtn = actor.find('ballBtn',_scn)
		local range = screenW2*0.8
		
		createAdView()
		resource.createFromString([[
		<Actions name="showCloseBtn" >
			<Action Method="setProperty" p1="visible" p2="true" p3="closeAdsBtn" />
			<Action Method="setProperty" p1="positionx" p2="]] .. math.random(-range,range) .. [["  p3="closeAdsBtn" />
		</Actions>
		<Timeline name="moveBtn" autoplay="1" >
			<animation anim="moveBtn" target="position" onEnd="showCloseBtn" repeat="1"/>
			<animation anim="spin" target="angle" />
		</Timeline>
		]],ballBtn)
		actor.set(ballBtn,'timeline','moveBtn')
	else
		resource.createFromString([[
		<canvas name="bg" size="-100,-100" brush="whiterect" />
		<Label Name="Ads" text="your ad here" docking="top" layer="2" Size="-100, -15" font="serif" textColour="0,0,0,255" />
		]],_scn)
		scene.set(_scn,'position', -screenW*1.5 .. ',0')	
		resource.createFromString([[
		<Actions name="loaded">
			<Action method="setProperty" p1="active" p2="false" />
		</Actions>
		<Timeline name="wait" autoplay="1" >
			<animation anim="dummyfade" target="opacity" onEnd="loaded" />
		</Timeline>
		]],_scn)
		scene.set(_scn,'timeline','wait')
	end
	
	
	return 1
end


function hideAds()
	print('hide ads')
	local _scn = scene.find('reklama')
	scene.set(_scn,'physics',0)
	local pila = actor.find('pilka',_scn)
	actor.set(pila,'visible',0)
	resource.createFromString([[
		<Actions name="die" >
			<Action Method="CallGlobalScript" p1="freeMap" p3="reklama" p4="bieg"/>
		</Actions>
		<Animation name="oldmove" type="vec2" duration="1" >					
			<Frame value="0,0" time="0" />
			<Frame value="]] ..screenW .. ',0' .. [[" time="1" />
		</Animation>
		<Timeline name="oldmove" autoplay="1" >
			<animation anim="oldmove" target="position" onEnd="die" repeat="1" />
		</Timeline>
		]],_scn)
	scene.set(_scn,'timeline','oldMove')
	--create new scene
	return 1
end


function rateMe()
	if vendor== 'googleplay' then		
		sys.launchURL("https://play.google.com/store/apps/details?id=com.laggyluk.fufa2014")
	elseif vendor=='blackberry'  then
		
	elseif vendor=='amazon'then
		sys.launchURL('http://www.amazon.com/gp/mas/dl/android?asin=B00LFQDMM6')
	elseif vendor=='apple' then
		sys.launchURL('http://itunes.apple.com/WebObjects/MZStore.woa/wa/viewContentsUserReviews?id=879794953&pageNumber=0&sortOrdering=2&type=Lukasz+Karasowski&mt=8')
	elseif vendor=='samsung' then
		sys.launchURL('samsungapps://ProductDetail/com.bryancolin.turkeybounce')
	elseif vendor=='android' then --pre-play
	
	elseif vendor=='windows' or vendor=='wp8' then --win phone 8
		sys.launchURL('zune:reviewapp?appid=64031laggyluk.623144694D542')
	end	
	return 1
end

prefabs = [[
<animation name="scenebounceout" duration="0.3" type="float">
	<frame value="1" time="0" />
	<frame value="1.1" time="0.1" />
	<frame value="0" time="0.3" />
</animation>

<animation name="spin" duration="1" type="float">
	<frame value="0" time="0" />
	<frame value="-360" time="1" />
</animation>
<animation name="dummyfade" duration="1" type="float">
	<frame value="255" time="0" />
	<frame value="255" time="1" />
</animation>
<animation name="fadein" duration="1" type="float">
	<frame value="0" time="0" />
	<frame value="255" time="1" />
</animation>
<animation name="fadeout" duration="1" type="float">
	<frame value="255" time="0" />
	<frame value="0" time="1" />
</animation>

<template name="bramkarzT" >
	<Icon name="$name$" size="$size$" brush="$brush$" position="$pos$" 
		layer="2" depth="1.2" box2dmaterial="kinematic" collisionflags="1,1,1">
	</Icon>
</template>

<template name="pilkarzT" >
	<Icon name="$name$" size="$size$" brush="$brush$" position="$pos$" backgroundColour="$kolor$" aspectlock="x"
		layer="2" depth="1.2" box2dmaterial="kinematic" collisionflags="1,1,1" >
	<Icon name="$name$kolor" size="-100,-100" brush="$brush$Kolor" position="3,-1" aspectlock="x"/>	
	</Icon>
</template>
	
	
]]
